﻿-- 2022.09.16 单据同步按分录即时核算
-- 缓冲池
IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_CAL_BUFFERPOOL')
CREATE TABLE T_CAL_BUFFERPOOL (
	FID BIGINT DEFAULT 0 NOT NULL,
	FENTITY VARCHAR(80) DEFAULT ' ' NOT NULL,
	FBILLID BIGINT DEFAULT 0 NOT NULL,
	FENTRYID BIGINT DEFAULT 0 NOT NULL,
	FMATERIALID BIGINT DEFAULT 0 NOT NULL,
	FISMATERIALTRANS CHAR(1) DEFAULT '0' NOT NULL,
	FACTIONNAME VARCHAR(30) DEFAULT ' ' NOT NULL,
	FISSUCESS CHAR(1) DEFAULT '0' NOT NULL,
	FACTIONTIME DATETIME
);

-- 互斥表
IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_CAL_MQMUTEX')
CREATE TABLE T_CAL_MQMUTEX (
	FMQKEY VARCHAR(50) NOT NULL DEFAULT ' '
);

-- 日志增加分录
IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_CAL_BUSINESSLOGENTRY')
CREATE TABLE T_CAL_BUSINESSLOGENTRY (
	FENTRYID BIGINT DEFAULT 0 NOT NULL,
	FID BIGINT DEFAULT 0 NOT NULL,
	FSEQ INT DEFAULT 0 NOT NULL,
	FCOSTRECORDEID BIGINT DEFAULT 0 NOT NULL,
	FERRORINFO NVARCHAR(255) DEFAULT ' ' NOT NULL,
  FERRORINFO_TAG NCLOB
);

-- 失败成本域信息表
IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_CAL_FAILCOSTDOMAIN')
CREATE TABLE T_CAL_FAILCOSTDOMAIN (
	FID BIGINT DEFAULT 0 NOT NULL,
	FFAILCOSTDOMAINKEY VARCHAR(50) DEFAULT ' ' NOT NULL,
	FTIMES INT DEFAULT 0 NOT NULL
);

-- 核算成本记录、成本调整单、初始核算单增加字段：成本域字符串

IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_CAL_CALCOSTRECORDENTRY' AND KSQL_COL_NAME ='FCOSTDOMAINKEY')
 ALTER TABLE T_CAL_CALCOSTRECORDENTRY ADD (FCOSTDOMAINKEY VARCHAR(50) DEFAULT ' ' NOT NULL);

IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_CAL_COSTADJUSTBILLENTRY' AND KSQL_COL_NAME ='FCOSTDOMAINKEY')
 ALTER TABLE T_CAL_COSTADJUSTBILLENTRY ADD (FCOSTDOMAINKEY VARCHAR(50) DEFAULT ' ' NOT NULL );

IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_CAL_INITBILLENTRY' AND KSQL_COL_NAME ='FCOSTDOMAINKEY')
 ALTER TABLE T_CAL_INITBILLENTRY ADD (FCOSTDOMAINKEY VARCHAR(50) DEFAULT ' ' NOT NULL );

-- 成本调整单、初始核算单增加字段：分录状态

IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_CAL_COSTADJUSTBILLENTRY' AND KSQL_COL_NAME ='FENTRYSTATUS')
 ALTER TABLE T_CAL_COSTADJUSTBILLENTRY ADD (FENTRYSTATUS CHAR(1) DEFAULT 'C' NOT NULL );

 IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_CAL_INITBILLENTRY' AND KSQL_COL_NAME ='FENTRYSTATUS')
 ALTER TABLE T_CAL_INITBILLENTRY ADD (FENTRYSTATUS CHAR(1) DEFAULT 'C' NOT NULL );
