﻿-- 同步单据日志优化需求和多语言修复相关
-- 殷政 2020-1-7

-- 服务日志表增加是否关闭和关闭原因字段
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_CAL_SERVICELOG' AND KSQL_COL_NAME ='FISCLOSE') 
 ALTER TABLE T_CAL_SERVICELOG ADD (FISCLOSE CHAR(1) DEFAULT '0' NOT NULL );
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_CAL_SERVICELOG' AND KSQL_COL_NAME ='FCLOSEREASON') 
 ALTER TABLE T_CAL_SERVICELOG ADD (FCLOSEREASON NVARCHAR(1024) DEFAULT ' ' NOT NULL );
 
-- 服务日志增加多语言表
IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_CAL_SERVICELOG_L') 
 CREATE TABLE T_CAL_SERVICELOG_L (
FPKID VARCHAR(36) DEFAULT ' ' NOT NULL,
FID BIGINT DEFAULT 0 NOT NULL,
FLOCALEID VARCHAR(10) DEFAULT ' ' NOT NULL,
FCLOSEREASON NVARCHAR(1024) DEFAULT ' ' NOT NULL
);

-- 核算单据同步配置增加多语言表
IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_CAL_CALBILLRULE_L') 
 CREATE TABLE T_CAL_CALBILLRULE_L (
FPKID VARCHAR(36) DEFAULT ' ' NOT NULL,
FID BIGINT DEFAULT 0 NOT NULL,
FLOCALEID VARCHAR(10) DEFAULT ' ' NOT NULL,
FERRORTIP NVARCHAR(1024) DEFAULT ' ' NOT NULL
);

-- 核算单据同步配置增加自定义异常提示的字段
IF NOT EXISTS (SELECT 1 FROM KSQL_USERCOLUMNS WHERE KSQL_COL_TABNAME = 'T_CAL_CALBILLRULE' AND KSQL_COL_NAME ='FERRORTIP') 
 ALTER TABLE T_CAL_CALBILLRULE ADD (FERRORTIP NVARCHAR(1024) DEFAULT ' ' NOT NULL );

-- 差异分摊记录增加多语言表
IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_CAL_DIFFALLOCRC_L') 
 CREATE TABLE T_CAL_DIFFALLOCRC_L (
FPKID VARCHAR(36) DEFAULT ' ' NOT NULL,
FID BIGINT DEFAULT 0 NOT NULL,
FLOCALEID VARCHAR(10) DEFAULT ' ' NOT NULL,
FOPERATION NVARCHAR(80) DEFAULT ' ' NOT NULL
);

-- 单价类别增加多语言表
IF NOT EXISTS (SELECT 1 FROM KSQL_USERTABLES WHERE KSQL_TABNAME = 'T_CAL_PRICELIBENTRY_L') 
 CREATE TABLE T_CAL_PRICELIBENTRY_L (
FPKID VARCHAR(36) DEFAULT ' ' NOT NULL,
FENTRYID BIGINT DEFAULT 0 NOT NULL,
FLOCALEID VARCHAR(10) DEFAULT ' ' NOT NULL,
FPRICENAME NVARCHAR(80) DEFAULT ' ' NOT NULL
);

